Paper/scripts/applyPatches.sh

109 lines
3.1 KiB
Bash
Raw Normal View History

2016-04-02 03:55:54 +00:00
#!/usr/bin/env bash
(
PS1="$"
basedir="$(cd "$1" && pwd -P)"
2016-04-02 03:55:54 +00:00
workdir="$basedir/work"
minecraftversion=$(cat "$workdir/BuildData/info.json" | grep minecraftVersion | cut -d '"' -f 4)
gitcmd="git -c commit.gpgsign=false"
applycmd="$gitcmd am --3way --ignore-whitespace"
# Windows detection to workaround ARG_MAX limitation
windows="$([[ "$OSTYPE" == "cygwin" || "$OSTYPE" == "msys" ]] && echo "true" || echo "false")"
echo "Rebuilding Forked projects.... "
function applyPatch {
what=$1
2016-04-02 03:55:54 +00:00
what_name=$(basename "$what")
target=$2
branch=$3
cd "$basedir/$what"
$gitcmd fetch
$gitcmd branch -f upstream "$branch" >/dev/null
cd "$basedir"
if [ ! -d "$basedir/$target" ]; then
$gitcmd clone "$what" "$target"
fi
cd "$basedir/$target"
2016-04-14 03:39:54 +00:00
echo "Resetting $target to $what_name..."
$gitcmd remote rm upstream > /dev/null 2>&1
$gitcmd remote add upstream "$basedir/$what" >/dev/null 2>&1
$gitcmd checkout master 2>/dev/null || $gitcmd checkout -b master
$gitcmd fetch upstream >/dev/null 2>&1
$gitcmd reset --hard upstream/upstream
2016-04-14 03:39:54 +00:00
echo " Applying patches to $target..."
2016-04-14 03:39:54 +00:00
statusfile=".git/patch-apply-failed"
rm -f "$statusfile"
$gitcmd am --abort >/dev/null 2>&1
# Special case Windows handling because of ARG_MAX constraint
if [[ $windows == "true" ]]; then
echo " Using workaround for Windows ARG_MAX constraint"
find "$basedir/${what_name}-Patches/"*.patch -print0 | xargs -0 $applycmd
else
$applycmd "$basedir/${what_name}-Patches/"*.patch
fi
if [ "$?" != "0" ]; then
echo 1 > "$statusfile"
echo " Something did not apply cleanly to $target."
echo " Please review above details and finish the apply then"
echo " save the changes with rebuildPatches.sh"
# On Windows, finishing the patch apply will only fix the latest patch
# users will need to rebuild from that point and then re-run the patch
# process to continue
if [[ $windows == "true" ]]; then
echo ""
echo " Because you're on Windows you'll need to finish the AM,"
echo " rebuild all patches, and then re-run the patch apply again."
echo " Consider using the scripts with Windows Subsystem for Linux."
fi
2013-01-19 08:18:20 +00:00
exit 1
else
rm -f "$statusfile"
echo " Patches applied cleanly to $target"
fi
}
2014-11-28 01:17:45 +00:00
# Move into spigot dir
2016-04-02 03:55:54 +00:00
cd "$workdir/Spigot"
basedir=$(pwd)
# Apply Spigot
(
applyPatch ../Bukkit Spigot-API HEAD &&
applyPatch ../CraftBukkit Spigot-Server patched
) || (
echo "Failed to apply Spigot Patches"
exit 1
) || exit 1
# Move out of Spigot
2016-04-02 03:55:54 +00:00
basedir="$1"
cd "$basedir"
2016-03-31 00:50:23 +00:00
echo "Importing MC Dev"
./scripts/importmcdev.sh "$basedir" || exit 1
2016-03-31 00:50:23 +00:00
# Apply paper
(
applyPatch "work/Spigot/Spigot-API" Paper-API HEAD &&
applyPatch "work/Spigot/Spigot-Server" Paper-Server HEAD
cd "$basedir"
# if we have previously ran ./paper mcdev, update it
if [ -d "$workdir/Minecraft/$minecraftversion/src" ]; then
./scripts/makemcdevsrc.sh "$basedir"
fi
) || (
echo "Failed to apply Paper Patches"
exit 1
) || exit 1
) || exit 1